
//   !hpf$ processors q(2, 3)
// 
//   !hpf$ template s(25, 20)
//   !hpf$ distribute s(block, cyclic(5)) onto q   ! boring cyclic !!
// 
//   real res(15, 10)
//   !hpf$ align res(i, j) with s(20 - j, i)
// 
//   !hpf$ processors p(3, 2)
// 
//   !hpf$ template t(50, 20)
//   !hpf$ distribute t(cyclic, block) onto p
// 
//   integer a(15, 20)
// 
//   !hpf$ align a(i, j) with t(5 + 2 * i, j)
// 
//   !hpf$ processors r(6)
// 
//   real b(20, 10)
//   !hpf$ distribute b(*, block) onto r
// 
//   integer i, j, k
// 
//   do i = 1, 15
//     do j = 1, 20
//       a(i, j) = i * j
//     end do
//   end do
// 
//   do j = 1, 20
//     do k = 1, 10
//       b(j, k) = 1.0 / (j + k)
//     end do
//   end do
// 
//   res = matmul(a, b)
// 
//   do i = 1, 15
//     print "(10f7.2)", res(i, :)
//   end do
// 
// end

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test10 {
  static SpmdEnv spmd;
  static Procs2 p;
  static BlockRange x,y;
  static Array2ddI a,b;
  static Range z;

}

#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 q(2, 3) ;

  BlockRange s1(25, q.dim(0)) ;
  BlockCyclicRange s2(20, q.dim(1), 5) ;

  Range x = s2.subrng(15, 0) ;
  Range y = s1.subrng(10, 18, -1) ;

  Array2<float> res(x, y, q) ;

  Procs2 p(3, 2) ;

  CyclicRange t1(50, p.dim(0)) ;
  BlockRange t2(20, p.dim(1)) ;

  Range i = t1.subrng(15, 6, 2) ;
  Range j = t2.subrng(20, 0) ;

  Array2<int> a(i, j, p) ;

  Procs1 r(6) ;

  //Range u(20) ;
  CollapsedRange u(20) ;
  BlockRange v(10, r.dim(0)) ;

  Array2<float> b(u, v, r) ;

  ON(p) {
    Index ii(i), ij(j) ;
    OVERALL(ii) {
      OVERALL(ij) {
	a(ii, ij) = (i.idx(ii) + 1) * (j.idx(ij) + 1) ;
      } ALLOVER(ij) ;
    } ALLOVER(ii) ;
  } NO(p) ;

  ON(r) {
    Index iu(u), iv(v) ;
    OVERALL(iu) {
      OVERALL(iv) {
        b(iu, iv) = 1.0 / (u.idx(iu) + 1 + v.idx(iv) + 1) ;
      } ALLOVER(iv) ;
    } ALLOVER(iu) ;
  } NO(r) ;

  matmul(res, a, b) ;

  aprintf("%7.2f%*N", res, y.size()) ;

  AdlibFinalize() ;
}


